* Job template
*
* pjwitte 2oi8+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*

        section code

        include dev8_keys_qdos_sms
        include dev8_keys_qlv
        include dev8_keys_qdos_io
        include dev8_keys_err


        bra.s   job_start

        ds.b    4
        dc.w    $4afb
        dc.w    7
        dc.b    'lsbytes '

        data 20

*
job_start
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Process file via filter and commit to memory:
* EX somefilter, somefile TO lsbytes_exe; long$(base) & long$(length) & 'H'
* or
* Put this file into memory:
* er = FEW(lsbytes_exe, somefile; long$(base) & long$(length) & 'H')
* where base is where you want to put it, and length is length of somefile
*
* And
* Get from memory to file via filter
* EX lsbytes_exe; long$(base) & long$(length) & 'I' TO somefilter, somefile
* where
* H => LBYTES and I => SBYTES
*

        move.w (a7)+,d1
        subq.w #1,d1            only one channel
        bne.s bye_nf

        move.l (a7)+,a0         a0 = input channel
        move.w (a7)+,d1         length of command string
        sub.w #9,d1             must be exactly 9
        bne.s bye_bp

        move.l (a7)+,a1         a1 = base address
        move.l (a7)+,d2         d2 = file length
        moveq #0,d0
        move.b (a7),d0          iof.load or iof.save

        moveq #forever,d3
        trap #do.io
        bra.s exit

bye_nf
        moveq #err.fdnf,d0
        bra.s exit

*
bye_bp
        moveq #err.ipar,d0
*

*
exit
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Job suicide with error code
*

        move.l d0,d3            transfer error code

        moveq #sms.myjb,d1      remove this job
        moveq #sms.frjb,d0
        trap #do.smsq

*
        end
