* Job template
*
* pjwitte 2oi8+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with QDOS, Minerva and SMSQ/E
*

        section code

        include dev8_keys_qdos_sms
        include dev8_keys_qlv
        include dev8_keys_qdos_io
        include dev8_keys_err


        bra.s   job_start

        ds.b    4
        dc.w    $4afb
        dc.w    6
        dc.b    'sbytes'

        data 16

*
job_start
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*
* ch = FOP_OVER(somefile)
* and
* EX somejob, #ch, sbytes_exe; long$(base) & long$(length)
* or
* EX sbytes_exe, #ch; long$(base) & long$(length)
*

        move.w (a7)+,d1
        subq.w #1,d1            only one channel
        bne.s bye_nf

        move.l (a7)+,a0         a0 = input channel
        move.w (a7)+,d1         length of command string
        subq.w #8,d1            must be exactly 8
        bne.s bye_bp

        move.l (a7)+,a1         a1 = base address
        move.l (a7)+,d2         d2 = file length

        moveq #forever,d3
        moveq #iof.save,d0
        trap #do.io
        move.l d0,d3            any error code
        bra.s exit

bye_nf
        moveq #err.fdnf,d0
        bra.s bye

*
bye_bp
        moveq #err.ipar,d0
*
bye
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Job suicide with error message
*
* input : d0 = error code
*

        move.l d0,d3            transfer error code
        move.w ut.wersy,a2
        jsr (a2)

*
exit
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Job suicide with error code
*
* input : d3 = error code
*
        moveq #sms.myjb,d1            remove this job
        moveq #sms.frjb,d0
        trap #do.smsq

*
        end
